
!Exception methodsFor: '*ma object serialization' stamp: 'cmm 9/21/2003 23:18'!
maPreserialize

	super maPreserialize.
	signalContext _ nil.
	handlerContext _ nil.
	outerContext _ nil! !


!MaMutatingProxy methodsFor: 'private actions' stamp: 'cmm 9/23/2003 01:19'!
becomeForward: otherObject copyHash: copyHash
	"Primitive. All variables in the entire system that used to point to the receiver now point to the argument.
	If copyHash is true, the argument's identity hash bits will be set to those of the recevier.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)
				copyHash: copyHash! !


!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 9/21/2003 21:25'!
newSkeletonFor: aMaObjectBuffer fromProxy: aMaBufferedObjectProxy

	| skel |

	skel _ aMaObjectBuffer skeletonObjectUsing: self.
	aMaBufferedObjectProxy ifNotNil: [ aMaBufferedObjectProxy becomeForward: skel copyHash: false ].
	oidManager
		oidOf: skel
		is: aMaObjectBuffer oid.
	^skel! !


!MaUpgradeableObject methodsFor: 'private actions' stamp: 'cmm 9/21/2003 21:25'!
upgradeUsing: aMaObjectSerializer
	"A really wild method, this performs an 'upgrade' on the receiver until it
	conforms to the current class version in the image."

	| classIdManager upgrade oid |
	classIdManager _ aMaObjectSerializer classIdManager.
	upgrade _ self.
	[ upgrade class == self class ] whileTrue:
		[ | nextUpgradeClass nextUpgrade |
		"upgradeClassFor: returns a class or aMaUpgradeableObject"
		nextUpgradeClass _ classIdManager upgradeClassFor: upgrade.
self maMarked: 'dev'.  "after VI4, we can use user-stored upgradeBlocks..
nextUpgrade _ upgrade definition upgradeBlock"
		nextUpgrade _ self class defaultUpgradeBlock
				value: upgrade
				value: nextUpgradeClass.
		upgrade _ nextUpgrade ].
	oid _ aMaObjectSerializer cleanObject: self.
	self becomeForward: upgrade copyHash: false.
	oid ifNotNil: [ aMaObjectSerializer oidManager oidOf: upgrade is: oid ].
	aMaObjectSerializer finalizeOids! !


!MagmaSession methodsFor: 'private' stamp: 'cmm 9/21/2003 21:25'!
cleanUp

	"need notNil guard for when a MaModelConflict is signaled during connecting, and the handler disconnects and cleanUp."
	largeCollections ifNotNil: [ largeCollections do: [ : each | each maRemoveVirtualVariables ] ].
	MagmaNotification signal: 'Cleaning proxies, please wait...'.
	Transcript cr; show: 'cleaning ', MaOdbmsProxy allInstances size printString, ' proxies..'.
	MaOdbmsProxy allInstances do: [ : each | each session id = id ifTrue: [ each becomeForward: nil copyHash: false ] ]! !

